#!/bin/bash
# (c) VP-Systeme MRi
# Das Skript fuert einen Request auf die Extranet Server Queue aus und holt offene Queue Eintraege ab
# Letztes Update: 2018-07-05 VPS DJE

# Schluesselwoerter die vom Cloudserver zurueckgegeben werden
keyword0='version'
keyword='push'
keyword2='rooms'
keyword3='firstHC'
keyword4='secondHC' 
keyword5='thirdHC'
keyword6='hotwaterLock'
keyword7='desinfection'
keyword8='pool'
keyword9='poolpriority'
keyword10='cool'
keyword11='statusinfo'


# Logfilename
logfile='debug.log'

# Pfade
path2psc='/usr/local/root/flash/bin_users'
path2conf='/usr/local/root/flash/etc/sysconfig/conf_users'

# Funktionen
# Setzt den Raum-Switch
setroom() {
	pcourl="$phost usr-cgi/query.cgi?var|I|64|$1"
	$gwc $pcourl
}

# Setzt die Switches fuer den 2. HZ
sethc2() {
	#pcourl="$phost usr-cgi/query.cgi?var|I|64|$1|I|81|2"
	pcourl="$phost usr-cgi/query.cgi?var|I|64|$1"
	$gwc $pcourl
}

# Setzt den Switch fr die Statusdaten im 2. HZ
sethc2cond() {
	pcourl="$phost usr-cgi/query.cgi?var|I|81|2"
	$gwc $pcourl
}

# Setzt die Switches fuer den 3. HZ
sethc3() {
	pcourl="$phost usr-cgi/query.cgi?var|I|64|$1"
	$gwc $pcourl
}

# Setzt den Switch fr die Statusdaten im 3. HZ
sethc3cond() {
	pcourl="$phost usr-cgi/query.cgi?var|I|81|3"
	$gwc $pcourl
}

# Anzahl der Raeume
getroomcount() {
	pcourl=" $phost usr-cgi/xml.cgi?I|139|139"
	#2-stellig
	$gwc $pcourl |cut -c58-59
}

getroomcount2() {
	pcourl=" $phost usr-cgi/xml.cgi?I|141|141"
	#2-stellig
	$gwc $pcourl |cut -c58-59
}
getroomcount3() {
	pcourl=" $phost usr-cgi/xml.cgi?I|143|143"
	#2-stellig
	$gwc $pcourl |cut -c58-59
}

# start loop
while :
do
	echo -e "date1="`date +%d.%m.%y-%H:%M:%S` > log.txt
	begin='Ready'
	echo -e "start="$begin >> log.txt
	
	#begin='Beginn Durchlauf!'
	#echo -e "start="$begin >> log.txt
	# Settings einlesen
	cd $path2conf
	. ./settings2.conf
	cd $path2psc
	

	# Bedingung, ob ueberhaupt gepullt werden soll
	# if [ $onoff = $onoffval ]
	if [ 1 = $onoffval ]
	then
		echo -e "date10="`date +%d.%m.%y-%H:%M:%S` >> log.txt
		beginloop='BeginLoop'
		echo -e "begin="$beginloop >> log.txt
		req_action="pullRequest"
		URL="$ehost /$index action=""$req_action""&username=""$euser""&pluginversion=""$plugv"
		$pwc $URL |tail -1 > crypt.out
		
		# Entschluesseln der Daten (payload)
		repl=`cat crypt.out | sed 's/[^0-9^a-h]*//g'`
		reply=`$blowdec $repl $ckey`
		#echo "Rueckgabe: $reply"
		echo -e "date2="`date +%d.%m.%y-%H:%M:%S` > request.txt
		request='pullRequest: '
		echo -e "pullRequest="$request >> request.txt
		echo -e "reply1="`echo $reply | cut -c1-60`"..." >> request.txt
		#echo -e "reply1="$reply >> request.txt
		if [ `./parse.sh $reply 1` != 'noData' ] && [ `./parse.sh $reply 1` != $keyword11 ] && [ `./parse.sh $reply 1` != $keyword ] && [ `./parse.sh $reply 1` != $keyword0 ]
		then
			# echo 
			req_id=`./parse.sh $reply 1`
			req_val=`./parse.sh $reply 2`
							
			PCOURL=" $phost usr-cgi/query.cgi?$req_val"

			pcoreply=`$gwc $PCOURL`
			cryptreply=`$blowenc "$pcoreply" $ckey`

			req_action="pushAnswer"

			URL="$ehost /$index  action=""$req_action""&username=""$euser""&data=""$cryptreply""&request_id=""$req_id"

			$pwc $URL
			
		
		elif [ `./parse.sh $reply 1` = $keyword ]
		then
			# push status
			req_action="pushStatus"

			fconf=`./parse.sh $reply 2`
			# Statusdaten
			sethc2cond
			sleep 1
			xmlcontent=`echo "<DATA>"`
			xmlcontent=$xmlcontent`echo "<STATUSDATA>"`
			pcourl=" $phost usr-cgi/xml.cgi?$fconf"
			xmlcontent=$xmlcontent`$gwc $pcourl`
			xmlcontent=$xmlcontent`echo "</STATUSDATA>"`
			xmlcontent=$xmlcontent`echo "<CONDHC2>"`
			pcohc2cond="$phost usr-cgi/xml.cgi?$h2cond"
			xmlcontent=$xmlcontent`$gwc $pcohc2cond`
			xmlcontent=$xmlcontent`echo "</CONDHC2>"`
			sethc3cond
			sleep 1
			xmlcontent=$xmlcontent`echo "<CONDHC3>"`
			pcohc3cond="$phost usr-cgi/xml.cgi?$h3cond"
			xmlcontent=$xmlcontent`$gwc $pcohc3cond`
			xmlcontent=$xmlcontent`echo "</CONDHC3>"`
			
			xmlcontent=$xmlcontent`echo "</DATA>"`
			# if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" statusxml= $xmlcontent" >> $logfile; fi
			# Verschluesseln mit blowfish (cbc)
			cdata=`$blowenc $xmlcontent $ckey`
			content=`echo -e "$ehost /$index action=""$req_action""&username=""$euser""&data=\c"`$cdata
			# Antwort mit Header nach crypt2 schreiben	
			#$pwc $content > crypt2.out
			$pwc $content |tail -1 > crypt2.out			
			#MTH: Abschneiden der Nicht-Hex Zeichen bei Problemen POST-Kommunikation
			repl2=`cat crypt2.out | sed 's/[^0-9^a-h]*//g'`
			if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" profilstring_enc= $repl2" >> $logfile; fi			
			# Entschlsseln des Payloads
		    reply2=`$blowdec $repl2 $ckey`		    
		    echo -e "date3="`date +%d.%m.%y-%H:%M:%S` > pushstatus.txt
		    echo -e "pushr="`echo $reply2 | cut -c1-60`"..." >> pushstatus.txt    		    						    
		    echo -e "pushStatus=pushStatus" >> pushstatus.txt			
			
			if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" profilstring= $repl2" >> $logfile; fi
			
			# Root Tag
			xmlcontent=`echo "<DATA>"`
						
			# Aktion pushRooms gilt fr alle Kreise, nicht nur Rume
			req_action="pushRooms"
			echo -e "pushRooms=pushRooms:" >> pushstatus.txt
			# Abholen der Raeume, wenn angefordert
			if [ `./parse.sh $reply2 1` = $keyword2 ]
			then
				# erste und zweite Stelle
				roomstring=`getroomcount`
				r1=`echo $roomstring |cut -c1-1`
				r2=`echo $roomstring |cut -c2-2`
				if [ $r2 = '<' ] 
				then
					rooms=$(($r1))
					#if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" roomcount1= $rooms" >> $logfile; fi
				else
					rooms=$(($r1*10+$r2))
					#if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" roomcount2= $rooms" >> $logfile; fi
				fi
				cnt=0

				# Beginn Tag
				xmlcontent=$xmlcontent`echo "<ROOMS>"`

				# Loop ber alle Raeume 
				while [ $cnt -lt $rooms ]
				do
					roomid=$((50 + $cnt))
					setroom $roomid
					sleep 1
					pcoroomsurl="$phost usr-cgi/xml.cgi?$rdata"
					xmlcontent=$xmlcontent`$gwc $pcoroomsurl`
					cnt=$(($cnt + 1))
				done

				# End Tag
				xmlcontent=$xmlcontent`echo "</ROOMS>"`
			fi
			
			# Abholen des ersten Heizkries wenn angefordert
			if [ `./parse.sh $reply2 1` = $keyword3 ]
			then				
				cnt=1
				# Beginn Tag
				xmlcontent=$xmlcontent`echo "<HC1>"`

				# Loop ber I64:1-2
				while [ $cnt -le 2 ]
				do
					roomid=$((0 + $cnt))
					setroom $roomid
					sleep 1
					pcoroomsurl="$phost usr-cgi/xml.cgi?$h1data"
					xmlcontent=$xmlcontent`$gwc $pcoroomsurl`
					cnt=$(($cnt + 1))
				done

				#End Tag
				xmlcontent=$xmlcontent`echo "</HC1>"`
			fi
			
			#Rume 2.Heizkreises
			if [ `./parse.sh $reply2 2` = $keyword2 ]
			then
				sethc2cond
				# erste und zweite Stelle
				roomstring=`getroomcount2`
				r1=`echo $roomstring |cut -c1-1`
				r2=`echo $roomstring |cut -c2-2`
				if [ $r2 = '<' ] 
				then
					rooms=$(($r1))
					#if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" roomcount12= $rooms" >> $logfile; fi
				else
					rooms=$(($r1*10+$r2))
					#if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" roomcount22= $rooms" >> $logfile; fi
				fi
				cnt=0

				# Beginn Tag
				xmlcontent=$xmlcontent`echo "<ROOMS2>"`

				# Loop ber alle Raeume 
				while [ $cnt -lt $rooms ]
				do
					roomid=$((60 + $cnt))
					setroom $roomid
					sleep 1
					pcoroomsurl="$phost usr-cgi/xml.cgi?$rdata"
					xmlcontent=$xmlcontent`$gwc $pcoroomsurl`
					cnt=$(($cnt + 1))
				done

				# End Tag
				xmlcontent=$xmlcontent`echo "</ROOMS2>"`
			fi
			
			
			#Abholen des zweiten Heizkreises wenn angefordert
			if [ `./parse.sh $reply2 2` = $keyword4 ]
			then				
				cnt=3
				#Beginn Tag
				xmlcontent=$xmlcontent`echo "<HC2>"`

				#Loop ber I64:3-4
				while [ $cnt -le 4 ]
				do
					roomid=$((0 + $cnt))
					sethc2 $roomid
					sleep 1
					pcoroomsurl="$phost usr-cgi/xml.cgi?$h2data"
					xmlcontent=$xmlcontent`$gwc $pcoroomsurl`
					cnt=$(($cnt + 1))
				done

				#End Tag
				xmlcontent=$xmlcontent`echo "</HC2>"`
			fi
			#Rume 3.Heizkreises
			if [ `./parse.sh $reply2 3` = $keyword2 ]
			then
				sethc3cond
				# erste und zweite Stelle
				roomstring=`getroomcount3`
				r1=`echo $roomstring |cut -c1-1`
				r2=`echo $roomstring |cut -c2-2`
				if [ $r2 = '<' ] 
				then
					rooms=$(($r1))
					#if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" roomcount12= $rooms" >> $logfile; fi
				else
					rooms=$(($r1*10+$r2))
					#if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" roomcount22= $rooms" >> $logfile; fi
				fi
				cnt=0

				# Beginn Tag
				xmlcontent=$xmlcontent`echo "<ROOMS3>"`

				# Loop ber alle Raeume 
				while [ $cnt -lt $rooms ]
				do
					roomid=$((70 + $cnt))
					setroom $roomid
					sleep 1
					pcoroomsurl="$phost usr-cgi/xml.cgi?$rdata"
					xmlcontent=$xmlcontent`$gwc $pcoroomsurl`
					cnt=$(($cnt + 1))
				done

				# End Tag
				xmlcontent=$xmlcontent`echo "</ROOMS3>"`
			fi
			
			#Abholen des dritten Heizkreises wenn angefordert
			if [ `./parse.sh $reply2 3` = $keyword5 ]
			then				
				cnt=5
				#Beginn Tag
				xmlcontent=$xmlcontent`echo "<HC3>"`

				#Loop ber I64:5-6
				while [ $cnt -le 6 ]
				do
					roomid=$((0 + $cnt))
					sethc3 $roomid
					sleep 1
					pcoroomsurl="$phost usr-cgi/xml.cgi?$h3data"
					xmlcontent=$xmlcontent`$gwc $pcoroomsurl`
					cnt=$(($cnt + 1))
				done

				#End Tag
				xmlcontent=$xmlcontent`echo "</HC3>"`
			fi
			
			#Abholen der Warmwassersperre
			if [ `./parse.sh $reply2 4` = $keyword6 ]
			then
				xmlcontent=$xmlcontent`echo "<HWLOCK>"`	
				setroom 7
				sleep 1
				pcoroomsurl="$phost usr-cgi/xml.cgi?$wdata"
				xmlcontent=$xmlcontent`$gwc $pcoroomsurl`				
				xmlcontent=$xmlcontent`echo "</HWLOCK>"`			
			fi
			
			#Abholen der Warmwasserdesinfection
			if [ `./parse.sh $reply2 5` = $keyword7 ]
			then
				xmlcontent=$xmlcontent`echo "<DINFECT>"`	
				setroom 8
				sleep 1
				pcoroomsurl="$phost usr-cgi/xml.cgi?$ddata"
				xmlcontent=$xmlcontent`$gwc $pcoroomsurl`				
				xmlcontent=$xmlcontent`echo "</DINFECT>"`			
			fi
			#Abholen Schwimmbad
			if [ `./parse.sh $reply2 6` = $keyword8 ]
			then
				xmlcontent=$xmlcontent`echo "<POOL>"`	
				setroom 9
				sleep 1
				pcoroomsurl="$phost usr-cgi/xml.cgi?$pdata"
				xmlcontent=$xmlcontent`$gwc $pcoroomsurl`				
				xmlcontent=$xmlcontent`echo "</POOL>"`			
			fi
			#Abholen Schwimmbad Vorrang
			if [ `./parse.sh $reply2 7` = $keyword9 ]
			then
				xmlcontent=$xmlcontent`echo "<POOLP>"`	
				setroom 10
				sleep 1
				pcoroomsurl="$phost usr-cgi/xml.cgi?$ppdata"
				xmlcontent=$xmlcontent`$gwc $pcoroomsurl`				
				xmlcontent=$xmlcontent`echo "</POOLP>"`			
			fi
			#Abholen dyn Cooling
			if [ `./parse.sh $reply2 8` = $keyword10 ]
			then
				xmlcontent=$xmlcontent`echo "<COOL>"`	
				setroom 11
				sleep 1
				pcoroomsurl="$phost usr-cgi/xml.cgi?$cooldata"
				xmlcontent=$xmlcontent`$gwc $pcoroomsurl`				
				xmlcontent=$xmlcontent`echo "</COOL>"`			
			fi
			#Umschiessendes ROOT Tag
			xmlcontent=$xmlcontent`echo "</DATA>"`

			if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`" profilxml= $xmlcontent" >> $logfile; fi
			
			cryptxmlcontent=`$blowenc $xmlcontent $ckey`
			content=`echo -e "$ehost /$index action=""$req_action""&username=""$euser""&data=\c"`$cryptxmlcontent
			$pwc $content
			if [ -n `./parse.sh $reply2 9` ] && [ `./parse.sh $reply2 9` = $keyword11 ]
			then
				echo -e "date3="`date +%d.%m.%y-%H:%M:%S` > statusinfo.txt
				echo -e "ErrorStatus=Statusinfo:" >> statusinfo.txt		
				echo -e "error="`./parse.sh $reply2 10` >> statusinfo.txt			
			fi
			
			#push status			
			sleep $stime
			
		elif [ `./parse.sh $reply 1` = $keyword0 ]
		# Versionsabfrage		
		then
			req_action="pushStatus"
			pcoroomsurl="$phost usr-cgi/xml.cgi?$vdata"
			xmlcontent=`$gwc $pcoroomsurl`			
			cryptxmlcontent=`$blowenc $xmlcontent $ckey`
			content=`echo -e "$ehost /$index action=""$req_action""&username=""$euser""&data=\c"`$cryptxmlcontent
			$pwc $content |tail -1 > crypt3.out
			repl3=`cat crypt3.out | sed 's/[^0-9^a-h]*//g'`
		    reply3=`$blowdec $repl3 $ckey`
		    info=`./parse.sh $reply3 1`
		    if [ `./parse.sh $reply3 1` = $keyword11 ]	
		    then
				echo -e "date3="`date +%d.%m.%y-%H:%M:%S` > version.txt
				echo -e "ErrorStatus=Version:" >> version.txt		
				echo -e "error="`./parse.sh $reply3 2` >> version.txt
			fi				    
		else 
			# NoData 
			sleep $stime
		fi
	else 
		# Uebertragung abgeschaltet, Schalter erneut auslesen nach:
		if [ $debug = "yes" ]; then echo -e `date +%d.%m.%y-%H:%M:%S`"pause" >> $logfile; fi
		sleep $stime
	fi
done
